## PyTraffic -- A python simulation of the game Rush Hour invented by
## Nob Yoshigahara and commercialized by Binary Arts Corporation.
##
## Copyright (C) 2001-2005 Michel Van den Bergh <michel.vandenbergh@uhasselt.be>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING.
## If not, write to the Free Software Foundation, Inc.,
## 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##


import gtk
import gobject

def _donothing(*args,**kw):
    pass

class Timer:
    def __init__(self,command=_donothing, interval=1000):
        self.command=command
        self.interval=interval
        self.__afterid=None

    def start(self):
        if self.__afterid==None:
            self.__afterid=gobject.timeout_add(self.interval,
                                       self.__commandwrapper)

    def set_command(self,command):
        self.command=command

    def stop(self):
        if self.__afterid!=None:
            gobject.source_remove(self.__afterid)
            self.__afterid=None

    def __commandwrapper(self):
        self.command()
        return True




